var $ytunblocker = jQuery.noConflict(true);

var oldPlayerUnavailableContent = '';

function loadSimilarVideo(autoplay) {
	var title = $ytunblocker('#info-contents #container h1.title').text();
	var ytUrl = 'https://www.youtube.com/results?search_query=' + encodeURIComponent(title);
	
	if (title != '') {
		var xhttp = new XMLHttpRequest();
		xhttp.onreadystatechange = function() {
			if (this.readyState == 4) {
				var scriptCode = this.responseText;  
				
				var spattern = '"videoId":"';
							
				var spos = scriptCode.indexOf(spattern);
				
				if (spos != -1) {
					spos = spos+spattern.length;
					
					var epos = scriptCode.indexOf('",', spos);
					
					if (epos != -1) {
						var videoId = scriptCode.substr(spos, epos-spos);
						
						if ($ytunblocker('#player #error-screen').length && $ytunblocker('#player #error-screen').is(":visible")) {
							oldPlayerUnavailableContent = $ytunblocker('#player #player-container').html();
							$ytunblocker('#player #error-screen').hide();
						}
											
						$ytunblocker('#player #player-container').html('<iframe id="similar-video-player" width="100%" height="100%" src="https://www.youtube.com/embed/' + videoId + '?autoplay=' + autoplay + '&showinfo=0" frameborder="0" allowfullscreen></iframe>');
						$ytunblocker('#player #player-container').css('visibility', 'visible');
						$ytunblocker('#player #player-container').show();
					 }
				 }
			}
		};
		
		xhttp.open("GET", ytUrl, true);
		xhttp.overrideMimeType('text/plain');
		xhttp.send();
	}
}

function resetSimilarVideo() {
	if (oldPlayerUnavailableContent != '') {
		$ytunblocker('#player #player-container').html(oldPlayerUnavailableContent);
		$ytunblocker('#player #player-container').css('visibility', 'hidden');
		$ytunblocker('#player #player-container').hide();
		$ytunblocker('#player #error-screen').show();
		addClickHandler();
	}
}

function addClickHandler() {
	var button = $ytunblocker('#youtube-unblock-button');
	button.unbind('click');
	button.click(function(event) {
		browser.runtime.sendMessage({'action': 'doUnblock'});
	});
    
    var button2 = $ytunblocker('#youtube-donation-button');
	button2.unbind('click');
	button2.click(function(event) {
		location.href = 'https://www.patreon.com/bePatron?c=1221838';
	});
}

function modHandleMessage(message) {
	if (message.action == '_applyModifications') {
		if ($ytunblocker('#info-contents #container h1.title').length) {
			if (message.type == 'change') {
				var element = $ytunblocker(message.selector);
				if (element) {
					element.html(message.content);
				}
			} else if (message.type == 'append') {
				var element = $ytunblocker(message.selector);
                var existing = $ytunblocker('#'+message.content_id).length;
                if (element && !existing) {
                    element.append(message.content);
                }
			} else if (message.type == 'remove') {
				var element = $ytunblocker(message.selector);
				if (element) {
					element.remove();
				}
			}
		}
	} else if (message.action == '_applyActions') {
		addClickHandler();
	} else if (message.action == '_setUnblockState') {
		if (message.state) {
			loadSimilarVideo(1);
		} else {
			resetSimilarVideo();
		}
	} else if (message.action == '_loadSimilarVideo') {
		loadSimilarVideo(message.autoplay);
	} else if (message.action == '_resetSimilarVideo') {
		resetSimilarVideo();
	}
}

browser.runtime.onMessage.addListener(modHandleMessage);

function checkModifications() {
	var button = $ytunblocker('#youtube-donation-button');
	
	if (!button.length) {
		setTimeout(checkModifications, 2000);
	}
    
    browser.runtime.sendMessage({'action': 'getModifications'});
}

checkModifications();

var lastUrl = '';

function check() {
	// load video in single mode, if it's in a playlist
	if ($ytunblocker('#player #error-screen').length && $ytunblocker('#player #error-screen').is(":visible")) {
		if (location.href.indexOf('list=') != -1) {
			var activeURL = location.href;
			var s1 = activeURL.indexOf('v=');
								
			if (s1 != -1) {
				var activeVideoID = activeURL.substring(s1+2);
				
				s1 = activeVideoID.indexOf('&');
				
				if (s1 != -1) {
					activeVideoID = activeVideoID.substring(0, s1);
				}
				
				location.href = 'https://www.youtube.com/watch?v=' + activeVideoID;
			}
		}
	}
	
	// check if url changed
	if (lastUrl != location.href) {
        browser.runtime.sendMessage({'action': 'getModifications'});
		browser.runtime.sendMessage({'action': 'getUnblockState'});
		
		lastUrl = location.href;
	}
}

check();

// create an observer instance
var observer = new MutationObserver(function(mutations) {
	mutations.forEach(function(mutation) {
		check();
	});    
});
 
// configuration of the observer:
var config = { attributes: true, childList: true, characterData: true };
 
// pass in the target node, as well as the observer options
observer.observe(document.body, config);


